searchData={"content_type":"text/markdown","items":[{"doc":"Reinforcement Learning training and inference framework","ref":"Rein.html","title":"Rein","type":"module"},{"doc":"","ref":"Rein.html#train/5","title":"Rein.train/5","type":"function"},{"doc":"The behaviour that should be implemented by a `Rein` agent module.","ref":"Rein.Agent.html","title":"Rein.Agent","type":"behaviour"},{"doc":"Initializes the agent state with the given agent-specific options.\n\nAlso calls `c:reset/2` in the end.","ref":"Rein.Agent.html#c:init/2","title":"Rein.Agent.init/2","type":"callback"},{"doc":"","ref":"Rein.Agent.html#c:optimize_model/1","title":"Rein.Agent.optimize_model/1","type":"callback"},{"doc":"Can be used to record the observation in an experience replay buffer.\n\nIf this is not desired, just make this function return the first argument unchanged.","ref":"Rein.Agent.html#c:record_observation/5","title":"Rein.Agent.record_observation/5","type":"callback"},{"doc":"Resets any values that aren't fixed for the agent state.","ref":"Rein.Agent.html#c:reset/2","title":"Rein.Agent.reset/2","type":"callback"},{"doc":"Selects the action to be taken.","ref":"Rein.Agent.html#c:select_action/2","title":"Rein.Agent.select_action/2","type":"callback"},{"doc":"","ref":"Rein.Agent.html#t:rl_state/0","title":"Rein.Agent.rl_state/0","type":"type"},{"doc":"An arbitrary `Nx.Container` that holds metadata for the agent","ref":"Rein.Agent.html#t:t/0","title":"Rein.Agent.t/0","type":"type"},{"doc":"Deep Deterministic Policy Gradient implementation.\n\nThis assumes that the Actor network will output `{nil, num_actions}` actions,\nand that the Critic network accepts `\"actions\"` input with the same shape.\n\nActions are deemed to be in a continuous space of type `:f32`.","ref":"Rein.Agents.DDPG.html","title":"Rein.Agents.DDPG","type":"module"},{"doc":"","ref":"Rein.Agents.DDPG.html#update_priorities/3","title":"Rein.Agents.DDPG.update_priorities/3","type":"function"},{"doc":"","ref":"Rein.Agents.DQN.html","title":"Rein.Agents.DQN","type":"module"},{"doc":"","ref":"Rein.Agents.DQN.html#update_priorities/4","title":"Rein.Agents.DQN.update_priorities/4","type":"function"},{"doc":"","ref":"Rein.Agents.QLearning.html","title":"Rein.Agents.QLearning","type":"module"},{"doc":"Soft Actor-Critic implementation.\n\nThis assumes that the Actor network will output `{nil, num_actions, 2}`,\nwhere for each action they output the $\\mu$ and $\\sigma$ values of a random\nnormal distribution, and that the Critic network accepts `\"actions\"` input with\nshape `{nil, num_actions}`, where the action is calculated by sampling from\nsaid random distribution.\n\nActions are deemed to be in a continuous space of type `:f32`.\n\nFor simplicity in the implementation of the Dual Q implementation,\n`:critic_params` is vectorized with the axis `:critics` with default\nsize 2. Likewise, `:critic_target_params` and `:critic_optimizer_state`\nare also vectorized in the same way.\n\nVectorized axes from `:random_key` are still propagated normally throughout\nthe agent state for parallel training.","ref":"Rein.Agents.SAC.html","title":"Rein.Agents.SAC","type":"module"},{"doc":"Defines an environment to be passed to `Rein`.","ref":"Rein.Environment.html","title":"Rein.Environment","type":"behaviour"},{"doc":"Applies the given action to the environment.\n\nReturns the updated environment, also updated with the reward\nand a flag indicating whether the new state is terminal.","ref":"Rein.Environment.html#c:apply_action/2","title":"Rein.Environment.apply_action/2","type":"callback"},{"doc":"Initializes the environment state with the given environment-specific options.\n\nAlso calls `c:reset/2` in the end.","ref":"Rein.Environment.html#c:init/2","title":"Rein.Environment.init/2","type":"callback"},{"doc":"The number of possible actions for the environment","ref":"Rein.Environment.html#c:num_actions/0","title":"Rein.Environment.num_actions/0","type":"callback"},{"doc":"Resets any values that aren't fixed for the environment state.","ref":"Rein.Environment.html#c:reset/2","title":"Rein.Environment.reset/2","type":"callback"},{"doc":"","ref":"Rein.Environment.html#t:rl_state/0","title":"Rein.Environment.rl_state/0","type":"type"},{"doc":"An arbitrary `Nx.Container` that holds metadata for the environment","ref":"Rein.Environment.html#t:t/0","title":"Rein.Environment.t/0","type":"type"},{"doc":"","ref":"Rein.Environments.Gridworld.html","title":"Rein.Environments.Gridworld","type":"module"},{"doc":"","ref":"Rein.Environments.Gridworld.html#as_state_vector/1","title":"Rein.Environments.Gridworld.as_state_vector/1","type":"function"},{"doc":"","ref":"Rein.Environments.Gridworld.html#bounding_box/0","title":"Rein.Environments.Gridworld.bounding_box/0","type":"function"},{"doc":"","ref":"Rein.Environments.Gridworld.html#state_vector_size/0","title":"Rein.Environments.Gridworld.state_vector_size/0","type":"function"},{"doc":"Circular Buffer utility via Nx Containers.","ref":"Rein.Utils.CircularBuffer.html","title":"Rein.Utils.CircularBuffer","type":"module"},{"doc":"","ref":"Rein.Utils.CircularBuffer.html#append/2","title":"Rein.Utils.CircularBuffer.append/2","type":"function"},{"doc":"","ref":"Rein.Utils.CircularBuffer.html#append_multiple/2","title":"Rein.Utils.CircularBuffer.append_multiple/2","type":"function"},{"doc":"","ref":"Rein.Utils.CircularBuffer.html#new/2","title":"Rein.Utils.CircularBuffer.new/2","type":"function"},{"doc":"Returns the data starting at the current index.\n\nThe oldest persisted entry will be the first entry in\nthe result, and so on.","ref":"Rein.Utils.CircularBuffer.html#ordered_data/1","title":"Rein.Utils.CircularBuffer.ordered_data/1","type":"function"},{"doc":"Ornstein-Uhlenbeck (OU for short) noise generator\nfor temporally correlated noise.","ref":"Rein.Utils.Noise.OUProcess.html","title":"Rein.Utils.Noise.OUProcess","type":"module"},{"doc":"","ref":"Rein.Utils.Noise.OUProcess.html#init/2","title":"Rein.Utils.Noise.OUProcess.init/2","type":"function"},{"doc":"","ref":"Rein.Utils.Noise.OUProcess.html#reset/1","title":"Rein.Utils.Noise.OUProcess.reset/1","type":"function"},{"doc":"","ref":"Rein.Utils.Noise.OUProcess.html#sample/2","title":"Rein.Utils.Noise.OUProcess.sample/2","type":"function"},{"doc":"# Reinforcement Learning\n\n```elixir\nmy_app_root = Path.join(__DIR__, \"..\")\n\nMix.install(\n  [\n    {:rein, path: my_app_root, env: :dev}\n  ],\n  config_path: Path.join(my_app_root, \"config/config.exs\"),\n  lockfile: Path.join(my_app_root, \"mix.lock\"),\n  # change to \"cuda118\" to use CUDA\n  system_env: %{\"XLA_TARGET\" => \"cpu\"}\n)\n```","ref":"gridworld.html","title":"Reinforcement Learning","type":"extras"},{"doc":"```elixir\nalias VegaLite, as: Vl\n\n{min_x, max_x, min_y, max_y} = Rein.Environments.Gridworld.bounding_box()\n\npossible_targets_l = [[div(min_x + max_x, 2), max_y - 2]]\n\npossible_targets_l =\n  for x   Vl.layers([\n    Vl.new()\n    |> Vl.data(name: \"target\")\n    |> Vl.mark(:point,\n      fill: true,\n      tooltip: [content: \"data\"],\n      grid: true,\n      size: [expr: \"height * 4 * #{:math.pi()} / #{max_y - min_y}\"]\n    )\n    |> Vl.encode_field(:x, \"x\", type: :quantitative)\n    |> Vl.encode_field(:y, \"y\", type: :quantitative)\n    |> Vl.encode_field(:color, \"episode\",\n      type: :nominal,\n      scale: [scheme: \"blues\"],\n      legend: false\n    ),\n    Vl.new()\n    |> Vl.data(name: \"trajectory\")\n    |> Vl.mark(:line, opacity: 0.5, tooltip: [content: \"data\"])\n    |> Vl.encode_field(:x, \"x\", type: :quantitative, scale: [domain: [min_x, max_x], clamp: true])\n    |> Vl.encode_field(:y, \"y\", type: :quantitative, scale: [domain: [min_y, max_y], clamp: true])\n    |> Vl.encode_field(:color, \"episode\",\n      type: :nominal,\n      scale: [scheme: \"blues\"],\n      legend: false\n    )\n    |> Vl.encode_field(:order, \"index\")\n  ])\n  |> Kino.VegaLite.new()\n  |> Kino.render()\n\nloss_widget =\n  Vl.new(width: width, height: height, title: \"Loss\")\n  |> Vl.data(name: \"loss\")\n  |> Vl.mark(:line,\n    grid: true,\n    tooltip: [content: \"data\"],\n    interpolate: \"step-after\",\n    point: true,\n    color: \"blue\"\n  )\n  |> Vl.encode_field(:x, \"episode\", type: :quantitative)\n  |> Vl.encode_field(:y, \"loss\",\n    type: :quantitative,\n    scale: [\n      domain: [0, 1],\n      type: \"linear\",\n      base: 10,\n      clamp: true\n    ]\n  )\n  |> Vl.encode_field(:order, \"episode\")\n  |> Kino.VegaLite.new()\n  |> Kino.render()\n\nreward_widget =\n  Vl.new(width: width, height: height, title: \"Total Reward per Epoch\")\n  |> Vl.data(name: \"reward\")\n  |> Vl.mark(:line,\n    grid: true,\n    tooltip: [content: \"data\"],\n    interpolate: \"step-after\",\n    point: true,\n    color: \"blue\"\n  )\n  |> Vl.encode_field(:x, \"episode\", type: :quantitative)\n  |> Vl.encode_field(:y, \"reward\",\n    type: :quantitative,\n    scale: [\n      domain: [-2, 2],\n      type: \"symlog\",\n      base: 10,\n      clamp: true\n    ]\n  )\n  |> Vl.encode_field(:order, \"episode\")\n  |> Kino.VegaLite.new()\n  |> Kino.render()\n\nnil\n```\n\n```elixir\n# 250 max_iter * 15 episodes\nmax_points = 1000\n\nplot_fn = fn axon_state ->\n  if axon_state.iteration > 1 do\n    episode = axon_state.epoch\n\n    Kino.VegaLite.clear(grid_widget, dataset: \"target\")\n    Kino.VegaLite.clear(grid_widget, dataset: \"trajectory\")\n\n    Kino.VegaLite.push(\n      grid_widget,\n      %{\n        x: Nx.to_number(axon_state.step_state.environment_state.target_x),\n        y: Nx.to_number(axon_state.step_state.environment_state.target_y),\n        episode: episode,\n        episode_group: rem(episode, 15)\n      },\n      dataset: \"target\"\n    )\n\n    Kino.VegaLite.push(\n      loss_widget,\n      %{\n        episode: episode,\n        loss: Nx.to_number(Nx.mean(axon_state.step_state.agent_state.loss))\n      },\n      dataset: \"loss\"\n    )\n\n    IO.inspect(\"Episode #{episode} ended\")\n\n    trajectory = axon_state.step_state.trajectory\n\n    idx = Nx.to_flat_list(trajectory[0][0..(axon_state.iteration - 1)//1] |> Nx.as_type(:s64))\n    x = Nx.to_flat_list(trajectory[1][0..(axon_state.iteration - 1)//1])\n    y = Nx.to_flat_list(trajectory[2][0..(axon_state.iteration - 1)//1])\n\n    points =\n      [idx, x, y]\n      |> Enum.zip_with(fn [index, x, y] ->\n        %{\n          x: x,\n          y: y,\n          index: index,\n          episode: episode,\n          episode_group: rem(episode, 15)\n        }\n      end)\n\n    Kino.VegaLite.push_many(grid_widget, points, dataset: \"trajectory\")\n  end\n\n  Kino.VegaLite.push(\n    reward_widget,\n    %{\n      episode: axon_state.epoch,\n      reward: Nx.to_number(axon_state.step_state.agent_state.total_reward)\n    },\n    dataset: \"reward\"\n  )\n\n  axon_state\nend\n```\n\n```elixir\nfilename = \"/Users/paulo.valente/Desktop/gridworld.bin\"\n\n{\n  q_policy,\n  experience_replay_buffer_index,\n  persisted_experience_replay_buffer_entries,\n  experience_replay_buffer,\n  total_episodes\n} =\n  try do\n    contents = File.read!(filename)\n    File.write!(filename   \"_bak\", contents)\n\n    %{serialized: serialized, total_episodes: total_episodes} = :erlang.binary_to_term(contents)\n\n    %{\n      q_policy: q_policy,\n      experience_replay_buffer_index: experience_replay_buffer_index,\n      persisted_experience_replay_buffer_entries: persisted_experience_replay_buffer_entries,\n      experience_replay_buffer: exp_replay_buffer\n    } = Nx.deserialize(serialized)\n\n    {q_policy, experience_replay_buffer_index, persisted_experience_replay_buffer_entries,\n     exp_replay_buffer, total_episodes}\n  rescue\n    File.Error ->\n      {%{}, 0, 0, nil, 0}\n  end\n\n# q_policy = %{}\n# total_episodes = 0\n# experience_replay_buffer = nil\n# persisted_experience_replay_buffer_entries = 0\n# experience_replay_buffer_index = 0\ntotal_episodes\n```\n\n```elixir\nq_policy\n```\n\n```elixir\nnum_observations = Rein.Environments.Gridworld.state_vector_size()\nnum_actions = Rein.Environments.Gridworld.num_actions()\n\npolicy_net =\n  Axon.input(\"state\", shape: {nil, num_observations})\n  |> Axon.dense(128, activation: :relu)\n  |> Axon.dense(64, activation: :relu)\n  |> Axon.dense(64, activation: :relu)\n  |> Axon.dense(num_actions)\n\n# These might seem redundant, but will make more sense for multi-input models\n\nenvironment_to_input_fn = fn env_state ->\n  %{\"state\" => Rein.Environments.Gridworld.as_state_vector(env_state)}\nend\n\nstate_vector_to_input_fn = fn state_vector ->\n  %{\"state\" => state_vector}\nend\n\nenvironment_to_state_vector_fn = &Rein.Environments.Gridworld.as_state_vector/1\n```\n\n```elixir\nKino.VegaLite.clear(grid_widget)\nKino.VegaLite.clear(loss_widget, dataset: \"loss\")\nKino.VegaLite.clear(reward_widget, dataset: \"reward\")\n\nepisodes = 5000\nmax_iter = 200\n\n{t, result} =\n  :timer.tc(fn ->\n    Rein.train(\n      {Rein.Environments.Gridworld, possible_targets: possible_targets},\n      {Rein.Agents.DQN,\n       policy_net: policy_net,\n       eps_max_iter: -1,\n       q_policy: q_policy,\n       persisted_experience_replay_buffer_entries: persisted_experience_replay_buffer_entries,\n       experience_replay_buffer_index: experience_replay_buffer_index,\n       experience_replay_buffer: experience_replay_buffer,\n       environment_to_input_fn: environment_to_input_fn,\n       environment_to_state_vector_fn: environment_to_state_vector_fn,\n       state_vector_to_input_fn: state_vector_to_input_fn},\n      plot_fn,\n      num_episodes: episodes,\n      max_iter: max_iter\n    )\n  end)\n\n# File.write!(\"/Users/paulo.valente/Desktop/results_#{NaiveDateTime.utc_now() |> NaiveDateTime.to_iso8601() |> String.replace(\":\", \"\")}.bin\", )\nserialized =\n  Nx.serialize(\n    Map.take(result.step_state.agent_state, [\n      :q_policy,\n      :experience_replay_buffer_index,\n      :experience_replay_buffer,\n      :persisted_experience_replay_buffer_entries\n    ])\n  )\n\ncontents =\n  :erlang.term_to_binary(%{serialized: serialized, total_episodes: total_episodes + episodes})\n\n# File.write!(filename, contents)\n\n\"#{Float.round(t / 1_000_000, 3)} s\"\n```\n\n```elixir\nFile.write!(filename, contents)\nresult.step_state.agent_state.q_policy\n```","ref":"gridworld.html#section","title":"Section - Reinforcement Learning","type":"extras"}]}